<?php
namespace Magento\Pakkepost\Ui\Component\Listing\Column;

use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Ui\Component\Listing\Columns\Column;

class PkpStatusRenderer extends Column
{
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    public function prepareDataSource(array $dataSource)
    {
        // get default logger and log the data
        $logger = \Magento\Framework\App\ObjectManager::getInstance()->get(\Psr\Log\LoggerInterface::class);
        $logger->debug('PkpStatusRenderer: ' . json_encode($dataSource));

        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as  & $item) {
                // Assuming 'pakkepost_status' is the column in your database table

                // log the data
                $logger->debug('PkpStatusRenderer: ' . $item['pakkepost_status']);

                $item[$this->getData('name')] = $item['pakkepost_status'] ? 'Sent' : 'Pending';
            }
            // render the $dataSource

        }

        return $dataSource;
    }
}
